unit uManagementBase;

interface
uses
  uSimpleUI;

type

  PMsgStrRec = ^TMsgStrRec; //  Record ڴ MsgStr
  TMsgStrRec = record
    MsgStr: string;
  end;

  TOnDispMsg = procedure(AMsg: string) of object;

  // ʵ ThreadDispMsg() 
  //  TSimpleUI ĵӦ֮һ
  // ҲΪ̳߳ṩ

  TManagementBase = class
  private
    procedure RimDispMsg(Param: Pointer); // ִ߳е Proc
    procedure RpMsgParam(Param: Pointer); // ͷ Param  Proc
  protected
    procedure DispMsg(AMsg: string);
    procedure ThreadDispMsg(AMsg: string);
  public
    OnDispMsg: TOnDispMsg;
  public
    procedure StartWork; virtual; abstract;
  end;

implementation

{ TManagementBase }

procedure TManagementBase.DispMsg(AMsg: string);
begin
  if Assigned(OnDispMsg) then
    OnDispMsg(AMsg);
end;

procedure TManagementBase.RimDispMsg(Param: Pointer);
begin
  DispMsg(PMsgStrRec(Param).MsgStr);
end;

procedure TManagementBase.RpMsgParam(Param: Pointer);
begin
  Dispose(PMsgStrRec(Param));
end;

procedure TManagementBase.ThreadDispMsg(AMsg: string);
var
  P: PMsgStrRec;
begin
  New(P);
  P.MsgStr := AMsg;
  TSimpleUI.ExeProcInMainThread(P, RimDispMsg, RpMsgParam);
end;

end.

