unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, uTestMgt;

type

 // һϵзװʹ Form ϣ١

  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button5: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FTestMgt: TTestMgt;
    procedure DispMsg(AMsg: string);
    procedure BtnStatusEvent(Btn: TButton; AEnable: Boolean);

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  LBtn: TButton;
begin
  LBtn := Sender as TButton;
  LBtn.Enabled := false;
  FTestMgt.Btnsum := LBtn;
  FTestMgt.Num := 100;
  FTestMgt.StartWork;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FTestMgt.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin

  FTestMgt := TTestMgt.Create;
  FTestMgt.OnDispMsg := self.DispMsg;
  FTestMgt.OnBtnStatus := self.BtnStatusEvent;

end;

{ TForm1 }

procedure TForm1.DispMsg(AMsg: string);
begin
  Memo1.Lines.Add(AMsg);
end;

procedure TForm1.BtnStatusEvent(Btn: TButton; AEnable: Boolean);
begin
  Btn.Enabled := AEnable;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  LBtn: TButton;
begin
  LBtn := Sender as TButton;
  LBtn.Enabled := false;
  FTestMgt.Btnsum := LBtn;
  FTestMgt.Num := -1;
  FTestMgt.StartWork;
end;

end.

